#ifndef INTERFACE_H
#define INTERFACE_H

// --- DO NOT EDIT THIS FILE --- DO NOT EDIT THIS FILE --- DO NOT EDIT THIS FILE ---
// --- DO NOT EDIT THIS FILE --- DO NOT EDIT THIS FILE --- DO NOT EDIT THIS FILE ---
// --- DO NOT EDIT THIS FILE --- DO NOT EDIT THIS FILE --- DO NOT EDIT THIS FILE ---

// IMPORTANT NOTE:  DO NOT CHANGE ANYTHING IN THIS HEADER FILE.  This defines
// the interface to the prefetcher and the main OoO performance model.  Changing
// anything in here will break the performance model

#define UINT32      unsigned int
#define INT32       int
#define ADDRINT     unsigned long long
#define COUNTER     unsigned long long
#define CacheAddr_t unsigned long long

typedef struct
{
  COUNTER      LastRequestCycle;    // Cycle in which this request took place
  CacheAddr_t  LastRequestAddr;     // Program Counter of the instruction that made the request 
  COUNTER      SequenceNumber;      // Sequence number of the instruction that made the request
  INT32        AccessType;          // Request type (Load:1, Store:2)
  CacheAddr_t  DataAddr;            // Virtual address for the data being requested
  bool         hit;                 // Did the request hit in the cache?
  bool         LastRequestPrefetch; // Was this a prefetch request?
  UINT32       LRU;                 // Currently unimplemented: contains a bogus value, DO NOT use it 
} PrefetchData_t;

// The processor calls this function every cycle to issue prefetches should the prefetcher want to
void IssuePrefetches( COUNTER cycle, PrefetchData_t *L1Data, PrefetchData_t * L2Data );

// The L1 prefetcher can call this function to issue prefetches into L1 cache
bool IssueL1Prefetch( COUNTER cycle, CacheAddr_t addr );

// The L2 prefetcher can call this function to issue prefetches into L2 cache
bool IssueL2Prefetch( COUNTER cycle, CacheAddr_t addr );

// Access functions for the bit associated with each cache line for the contestant to read and/or modify
INT32 GetPrefetchBit( UINT32 level, CacheAddr_t addr );
void  SetPrefetchBit( UINT32 level, CacheAddr_t addr );
void  UnSetPrefetchBit( UINT32 level, CacheAddr_t addr );

#endif

