#include "interface.h"  // Do NOT edit interface .h
#include "sample_prefetcher.h"

SamplePrefetcher *pref1;   // This is the L1 prefetcher
SamplePrefetcher *pref2;   // Thss is the L2 prefetcher

//
//  Function to initialize the prefetchers.  DO NOT change the prototype of this
//  function.  You can change the body of the function by calling your necessary
//  initialization functions.
//

void InitPrefetchers() // DO NOT CHANGE THE PROTOTYPE
{
    // INSERT YOUR CHANGES IN HERE

    pref1 = new SamplePrefetcher();
    pref2 = new SamplePrefetcher();
}


//
//  Function that is called every cycle to issue prefetches should the
//  prefetcher want to.  The arguments to the function are the current cycle,
//  the demand requests to L1 and L2 cache.  Again, DO NOT change the prototype of this
//  function.  You can change the body of the function by calling your necessary
//  routines to invoke your prefetcher.
//

// DO NOT CHANGE THE PROTOTYPE
void IssuePrefetches( COUNTER cycle, PrefetchData_t *L1Data, PrefetchData_t * L2Data )
{    

    // INSERT YOUR CHANGES IN HERE
    int i, j, k;
    MemLogEntry *entry;
    CacheAddr_t addr;

    // Issue L1 prefetches
    for(i = 0; i < 4; i++) {
        if((cycle == L1Data[i].LastRequestCycle) && (L1Data[i].hit == 0)) {
            entry = pref1->AccessEntry(0,L1Data[i].LastRequestAddr,L1Data[i].DataAddr);
            if(entry) {
                if(entry->count == 2) {

                    /*cout << "cycle: " << cycle;
                      cout << "   seq: " << L1Data[i].SequenceNumber;
                      cout << "   addr: " <<hex <<L1Data[i].LastRequestAddr <<dec;
                      cout << "   count: " << entry->count;
                      cout << "   pref: " << entry->last_mem_addr << endl; */

                    addr = L1Data[i].DataAddr;
                    for(j = 0; j < 2; j++) {
                        addr += entry->stride;
                        IssueL1Prefetch(cycle,addr);
                    }
                }
            }
        }
    }

    // Issue L2 prefetches
    if((cycle == L2Data->LastRequestCycle) && (L2Data->hit == 0)) {
        entry = pref2->AccessEntry( 0, L2Data->LastRequestAddr, L2Data->DataAddr);
        if(entry) {
            if(entry->trained) {

                /*cout << "cycle: " << cycle;
                  cout << "   seq: " << L2Data->SequenceNumber;
                  cout << "   addr: " <<hex <<L2Data->LastRequestAddr <<dec;
                  cout << "   count: " << entry->count;
                  cout << "   pref: " << entry->last_mem_addr << endl;*/

                addr = L2Data->DataAddr;
                for(k = 0; k < 8; k++) {
                    addr += entry->stride;
                    IssueL2Prefetch(cycle,addr);
                }
            }
        }
    }
}
